﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;
using System.Xml.Serialization;

namespace PersonListXMLSerializer
{
    public partial class Form1 : Form
    {
        List<Person> pList = new List<Person>();

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            foreach (Person p in pList)
                System.Diagnostics.Trace.WriteLine("XML Serialize: " + p.ToString());

            FileStream fs = new FileStream(@"C:\PersonList.xml", FileMode.Create, FileAccess.Write);
            XmlSerializer xs = new XmlSerializer(typeof(List<Person>));
            xs.Serialize(fs, pList);
            fs.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            System.Threading.Thread.Sleep(1000);
            FileStream fs = new FileStream(@"C:\PersonList.xml", FileMode.Open, FileAccess.Read);
            XmlSerializer xs = new XmlSerializer(typeof(List<Person>));
            pList = (List<Person>)xs.Deserialize(fs);
            fs.Close();

            listView1.Items.Clear();
            foreach (Person p in pList)
            {
                System.Diagnostics.Trace.WriteLine("XML Deserialize: " + p.ToString());
                listView1.Items.Add(p.ToListViewItem());
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            int value;
            if (int.TryParse(textBox2.Text, out value))
            {
                Person p = new Person(textBox1.Text, int.Parse(textBox2.Text), textBox3.Text, textBox4.Text);
                pList.Add(p);
                // add Person into ListView Control
                listView1.Items.Add(p.ToListViewItem());
            }
        }
    }
}
